import { NgModule } from '@angular/core';
import { CacheService } from './cache.service';
import { IonicStorageModule, Storage } from '@ionic/storage';
import { CacheStorageService } from './cache-storage.service';
var CacheModule = /** @class */ (function () {
    function CacheModule() {
    }
    CacheModule.forRoot = function (cacheConfig) {
        cacheConfig = Object.assign({ keyPrefix: '' }, cacheConfig);
        return {
            ngModule: CacheModule,
            providers: [
                {
                    provide: CacheService,
                    useFactory: function (storage) {
                        return new CacheService(new CacheStorageService(storage, cacheConfig.keyPrefix));
                    },
                    deps: [Storage]
                }
            ]
        };
    };
    CacheModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        IonicStorageModule.forRoot({
                            name: '__ionicCache',
                            driverOrder: ['indexeddb', 'sqlite', 'websql']
                        })
                    ]
                },] },
    ];
    return CacheModule;
}());
export { CacheModule };
//# sourceMappingURL=cache.module.js.map